#!/usr/bin/perl
# Creating inter.cgi

use warnings ;
use strict ;
use DB_File ;

## DECLARATIONS
our $dbdir;
require "../conf.pl"; #get $dbdir value from ../conf.pl
$dbdir = "../".$dbdir; #fix $dbdir

my @list ; # array of tags
my $prev ='' ; # checking repeated entrances on tag_id database
my $cnt = 0; # wild-card counter
my $post ;

# test $ENV{'QUERY_STRING'}
if( index($ENV{'QUERY_STRING'},"ps")!=0 ) { print "Content-type: text/html; charset=utf-8\n\n<html><body><p>Error0, with input data: ".index($ENV{'QUERY_STRING'},"borrar")."</p></body></html>"; exit 0;}
my ($name, $value) = split(/=/,$ENV{'QUERY_STRING'} );
if($name ne "ps") { print "Content-type: text/html; charset=utf-8\n\n<html><body><p>Error1, with input data.</p></body></html>"; exit 0;}
my ($start,$end) = split(/_/,$value);

## OPENING DATABASES

sub Compare { my ($key1,$key2)=@_; "\L$key2" cmp "\L$key1"; } # getting first the last post
$DB_BTREE->{'compare'} = \&Compare ; # specify the Perl sub that will do the comparison

my %titles ; # to handle TITLES DB
tie %titles, "DB_File", $dbdir."habla_titles.db", O_RDWR|O_CREAT, 0666, $DB_BTREE # opendb, if it does not exist create
	or die "Cannot open file 'titles': $!\n" ; # error :(
my %texts ; # to handle TEXTS DB
tie %texts, "DB_File", $dbdir."habla_texts.db", O_RDWR|O_CREAT, 0666, $DB_BTREE # opendb, if it does not exist create
	or die "Cannot open file 'texts': $!\n" ; # error :(

$DB_BTREE->{'flags'} = R_DUP ; # permit duplication in next DB's

my ($id_tag, %id_tag); # to handle ID->TAG DB
$id_tag = tie %id_tag, "DB_File", $dbdir."habla_id_tag.db", O_RDWR|O_CREAT, 0666, $DB_BTREE # opendb, if it does not exist create
	or die "Cannot open file id_tag: $!\n" ; # error :(
my ($tag_id, %tag_id); # to handle TAG->ID DB
$tag_id = tie %tag_id, "DB_File", $dbdir."habla_tag_id.db", O_RDWR|O_CREAT, 0666, $DB_BTREE # opendb, if it does not exist create
	or die "Cannot open file tag_id: $!\n" ; # error :(

my (@numid, $numid); # to handle NUMBER->ID RECNO DB
$numid = tie @numid, "DB_File", $dbdir."habla_numid.db", O_RDWR|O_CREAT, 0666, $DB_RECNO # opendb, if it does not exist create
	or die "Cannot open file 'numid': $!\n" ; # error :(

### CREATING HTML  # http server head
print "Content-type: text/html; charset=utf-8\n\n
<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n
<html><head>\n<title>Habla_</title>
<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">
<meta name=\"Name\" content=\"Content\">
<style type=\"text/css\">
body { color: purple; background-color: #dd3; }
h1 { font-size: 1.6em; padding: 0; margin: 0;}
h2 { font-size: 1.2em; padding: 0; margin: 0;}
h3 { font-size: 0.7em; padding: 0; margin: 0;}
#wrapper { margin-left: 13%; margin-right: 7%; }
#main { width: 60%; float: left; position: relative; }
.texto {font-size: 85%;}
.article { width: 100%; padding: 15px 0 40px 0; }
.article h2 { border-bottom: 1px solid #ccc; }
.article div a { color: #a14732; text-decoration: none; border-bottom: 1px dashed; }
.article ul { padding: 0; list-style: none; font-size: 0.8em;}
.article ul li { width: 80%; float: right; text-align: right; }
#sidebar { float: left; clear: none; position: relative; width: 30%; padding: 0 0 0 5%; font-size: 0.8em; }
#sidebar h2 { color: #777; padding: 34px 0 17px 0; margin-bottom: 10px; border-bottom: 1px solid #ccc; }
#sidebar ul { list-style: none ; padding: 0; margin: 0; }
#sidebar a { color: #c66; text-decoration: none; font-weight: bold; }
</style>
</head>\n
<body>\n<div id=\"wrapper\">Go to <a href=\"panel_manage.cgi\">Panel</a><br/><br/>\n\n<div id=\"main\">\n";

# BLOG LOOP
if($end-$start > 100) { $end = $start+100; } # no more than 100 posts
for (my $i = $start; $i <= $end; $i++ )
{
	my $id=$numid[$i];
	my($first, $second) = split(/<!---->/, $texts{$id}); # searching whereis "<!---->" which separate intro text from extended text
	@list = $id_tag->get_dup($id) ; # get a list of tags for actual post
	print "	<div class=\"article\"><h2>$titles{$id}</h2>".# show title, id
		"<h3>20".substr($id, 0, 2)." - ".substr($id, 2, 2)." - ".substr($id, 4, 2)."</h3>
		<p><form name=\"$id\" action=\"change2.cgi\" method=\"GET\" /><input type=\"hidden\" name=\"id\" value=\"".$id."\" /><input type=\"submit\" value=\"edit\" /></form></p><p><form name=\"$id\" action=\"delete.cgi\" method=\"GET\" /><input type=\"checkbox\" name=\"id\" value=\"".$id."\" /><input type=\"submit\" value=\"delete\" /></form></p>\n<div class=\"texto\">".# date
		$first."</div>\n<p><a href=\"commview.cgi?id=".$id."\">View comments</p><ul><li class=\"tags\">Tags: "; # show tags
	foreach (@list){ print " $_"; }
	print "</li>\n	</ul></div>";
}

print "\n</div> <!-- end of #main -->\n\n<div id=\"sidebar\">\n<div id=\"archive\">\n<h2>Archive</h2>\n<ul>";

# ARCHIVE 
# id = 18 digits date, starting with last 2 digits os year.
# we create  the date for a boundary between month and look for
# posts id greater than it.
for ($cnt = 0; $cnt < $numid->length; $cnt++ ) # looking for articles per year - month
{
	print "<li><a href=\"change1b.cgi?ps=$cnt";
	my $datecnt = 0;
	my $refer = int($numid[$cnt]/100000000000000)*100000000000000; # search month boundary
	while ( $numid[$cnt] > $refer)
	{
		$datecnt++ ;
		$cnt++ ;
	}
	my $yearmo = int($refer/100000000000000);
	$cnt = $cnt-1;
	print "_$cnt\">20".substr($yearmo,0,2)."-".substr($yearmo,2,2)."</a><span class=\"count\"> (".$datecnt.")</span></li>\n";
}

print "</ul>\n</div><!-- end of Archive -->\n</div><!-- end of sidebar -->\n";

### FINISHING HTML

print "\n</div> <!-- end of wrapper -->\n</body></html>";

### CLOSING DATABASES

untie %titles ; #closing db's
untie %texts ;
undef $id_tag ; untie %id_tag ;
undef $tag_id ; untie %tag_id ;
undef $numid ; untie @numid ;

1; # Correct finish with 1